#include "H8_register.h" /* H8/3067̃WX^ */
#include "RTL8019AS_register.h" /* RTL8019AS̃WX^ */
#include "packet_definition.h" /* pPbg̒` */
#include "global_variables.h" /* O[oϐ̒` */
#include "H8_register_function.h" /* H8/3067̃WX^̐ݒ */
#include "delay_function.h" /* ԑ҂̊֐ */
#include "LCD_function.h" /* SC1602B̊֐ */
#include "NIC_function.h" /* RTL8019AS̊֐ */
#include "matrix_key_function.h" /* }gNXEL[̊֐ */
#include "utility_function.h" /* ̂ق̊֐ */
#include "ARP_function.h" /* ARP̊֐ */
#include "text_packet_function.h" /* eLXgEf[^̃pPbg̊֐ */

void main(void)
{
   unsigned short i;
   char key, previous_key;
   unsigned char on_switch, previous_on_switch;
   unsigned char cursor, line;
   unsigned char packet_type;
   ARP_PACKET *arp_packet;
   
   H8_register_init(); /* H8/3067̃WX^̐ݒ */
   LCD_init(); /* SC1602B̏ */
   NIC_init(); /* RTL8019AS̏ */
   
   /* MIPAhX̐ݒ */
   src_IP[0] = 192;
   src_IP[1] = 168;
   src_IP[2] = 0;
   src_IP[3] = 100 + (P2DR & 0x07); /* fBbvEXCb`ɂđMIPAhXݒ肷 */
   
   /* IPAhX̐ݒ */
   dst_IP[0] = 192;
   dst_IP[1] = 168;
   dst_IP[2] = 0;
   dst_IP[3] = 2;
   
   src_port = 10000; /* M|[gԍ̐ݒ */
   dst_port = 20000; /* |[gԍ̐ݒ */
   
   LCD_clear(); /* \NA */
   LCD_control(0x80); /* J[\0sڂ̐擪Ɉړ */
   
   delay_ms(2000); /* 2000msi2bj̎ԑ҂ */
   
   ARP_request(packet); /* ARPNGXg */
   
   packet_type = 0; /* packet_type0ɂ */
   do
   {
      if (packet_receive(packet) != 1) /* pPbgMƂ */
      {
         arp_packet = (ARP_PACKET *)packet; /* packetARP_PACKET\̂ɓĂ͂߂ */
         if ((arp_packet -> eth_ethernet_type == 0x0806) && 
             /* ARP̃pPbĝƂ */
             (IP_compare(arp_packet -> arp_dst_IP, src_IP) == 0) && 
             /* pPbgɋLqĂ鈶IPAhXMIPAhXɈvƂ */
             (arp_packet -> arp_operation == 2)
             /* ARPvĈƂ */
            )
         {
            for (i = 0; i < 6; i++)
            {
               dst_MAC[i] = arp_packet -> arp_src_MAC[i];
               /* pPbgɋLqĂ鑗MMACAhXdst_MACɊi[ */
            }
            packet_type = 'a'; /* packet_type'a'ɂ */
         }
      }
   } while (packet_type != 'a'); /* packet_type'a'ɂȂ܂ő҂ */
   
   src_ip_id = 0; /* src_ip_id̏l */
   for (i = 0; i < 16; i++)
   {
      text_buffer[i] = ' '; /* eLXgEobt@󔒂ŃNA */
   }
   text_buffer[16] = 0x00; /* eLXgEobt@̍Ōiɂ */
   cursor = 0; /* cursoȑl */
   line = 0; /* linȅl */
   previous_key = 0; /* previous_key̏l */
   previous_on_switch = 1; /* previous_on_switch̏l */
   
   while (1) /* [v */
   {
      while (cursor < 16) /* cursor16Ƃ */
      {
         delay_ms(20);
         /* 20ms̎ԑ҂͂ނƂŁC`^OɂXCb`̌댟o */
         
         key = matrix_key_read(); /* ݂̃L[`FbN */
         
         if ((key != 0) && (key != previous_key))
         /* ݂̃L[0ł͂ȂCÕL[Ƃ͈قȂƂ */
         {
            if ((cursor == 0) && (line == 0)) /* cursor0Cline0̂Ƃ */
            {
               LCD_clear(); /* \NA */
               LCD_control(0x80); /* J[\0sڂ̐擪Ɉړ */
            }
            else if ((cursor == 0) && (line == 1)) /* cursor0Cline1̂Ƃ */
            {
               LCD_control(0xC0); /* J[\1sڂ̐擪Ɉړ */
            }
            LCD_display(key); /* tfBXvCɌ݂̃L[\ */
            text_buffer[cursor] = key; /* keytext_bufferɊi[ */
            cursor++; /* cursorCNg */
         }
         previous_key = key;
         /* ݂̃L[C̃`FbNɂ钼ÕL[ƂĒ` */
         
         if ((P5DR & 0x02) == 0x00) /* ݂ONXCb`ÎƂ */
         {
            on_switch = 0; /* on_switch0ɂ */
         }
         else if ((P5DR & 0x02) == 0x02) /* ݂ONXCb`It̂Ƃ */
         {
            on_switch = 1; /* on_switch1ɂ */
         }
         
         if ((on_switch == 0) && (on_switch != previous_on_switch))
         /* ݂ONXCb`IŁCOONXCb`̏ԂƂ͈قȂƂ */
         {
            text_packet_send(packet); /* eLXgEf[^̃pPbg𑗐M */
            src_ip_id++; /* ̃pPbĝ߂ɁCsrc_ip_idCNg */
            for (i = 0; i < 16; i++)
            {
               text_buffer[i] = ' '; /* eLXgEobt@󔒂ŃNA */
            }
            cursor = 0; /* cursor0ɖ߂ */
            line ^= 1; /* XORZɂāCline0̂Ƃ1Cline1̂Ƃ0ɂ */
         }
         previous_on_switch = on_switch;
         /* ݂ONXCb`̏ԂC̃`FbNɂONXCb`̏ԂƂĒ` */
      }
      
      /* cursor16ȏɂȂƂ */
      text_packet_send(packet); /* eLXgEf[^̃pPbg𑗐M */
      src_ip_id++; /* ̃pPbĝ߂ɁCsrc_ip_idCNg */
      for (i = 0; i < 16; i++)
      {
         text_buffer[i] = ' '; /* eLXgEobt@󔒂ŃNA */
      }
      cursor = 0; /* cursor0ɖ߂ */
      line ^= 1; /* XORZɂāCline0̂Ƃ1Cline1̂Ƃ0ɂ */
   }
}
