#include "H8_register.h" /* H8/3067̃WX^ */
#include "RTL8019AS_register.h" /* RTL8019AS̃WX^ */
#include "packet_definition.h" /* pPbg̒` */
#include "global_variables.h" /* O[oϐ̒` */
#include "H8_register_function.h" /* H8/3067̃WX^̐ݒ */
#include "delay_function.h" /* ԑ҂̊֐ */
#include "LCD_function.h" /* SC1602B̊֐ */
#include "NIC_function.h" /* RTL8019AS̊֐ */
#include "matrix_key_function.h" /* }gNXEL[̊֐ */
#include "utility_function.h" /* ̂ق̊֐ */
#include "ARP_function.h" /* ARP̊֐ */
#include "speech_packet_function.h" /* f[^̃pPbg̊֐ */
#include <machine.h> /* set_imask_ccr֐ */

/* sampling_8khz֐́C^C}荞݂ƂɌĂяo֐ */
#pragma interrupt(sampling_8khz)
void sampling_8khz(void)
{
   TISRA &= 0xFE; /* IMFA00ɖ߂ */
   
   if (da_buffer_flag == 0) /* da_buffer_flag0̂Ƃ */
   {
      DADR0 = da_buffer0[da_counter];
      /* da_buffer0Ɋi[Ă鉹f[^DA0ɏo͂ */
   }
   else if (da_buffer_flag == 1) /* da_buffer_flag1̂Ƃ */
   {
      DADR0 = da_buffer1[da_counter];
      /* da_buffer1Ɋi[Ă鉹f[^DA0ɏo͂ */
   }
   
   da_counter++; /* da_counterCNg */
   if (da_counter == 160) /* da_counter160ɂȂƂ */
   {
      da_buffer_flag ^= 1;
      /* XORZɂāCda_buffer_flag0̂Ƃ1Cda_buffer_flag1̂Ƃ0ɂ */
      
      da_counter = 0;
      /* da_counter0ɖ߂ */
   }
}

void main(void)
{
   unsigned short i;
   unsigned char packet_type;
   ARP_PACKET *arp_packet;
   SPEECH_PACKET *speech_packet;
   
   set_imask_ccr(0); /* H8/3067荞݂󂯕tԂɂ */
   
   H8_register_init(); /* H8/3067̃WX^̐ݒ */
   LCD_init(); /* SC1602B̏ */
   NIC_init(); /* RTL8019AS̏ */
   
   /* MIPAhX̐ݒ */
   src_IP[0] = 192;
   src_IP[1] = 168;
   src_IP[2] = 0;
   src_IP[3] = 100 + (P2DR & 0x07); /* fBbvEXCb`ɂđMIPAhXݒ肷 */
   
   src_port = 20000; /* M|[gԍ̐ݒ */
   
   LCD_clear(); /* \NA */
   LCD_control(0x80); /* J[\0sڂ̐擪Ɉړ */
   
   da_buffer_flag = 0; /* da_buffer_flag̏l */
   da_counter = 0; /* da_counteȑl */
   for (i = 0; i < 160; i++)
   {
      da_buffer0[i] = 128; /* da_buffer0̏lif[^̃ItZbg128j */
      da_buffer1[i] = 128; /* da_buffer1̏lif[^̃ItZbg128j */
   }
   
   TISRA |= 0x10; /* IMIEA01ɐݒ肵C^C}荞݂Lɂ */
   TSTR |= 0x01; /* STR01ɂă^C}0X^[g */
   
   while (1) /* [v */
   {
      packet_type = 0; /* packet_type0ɂ */
      
      if (packet_receive(packet) != 1) /* pPbgMƂ */
      {
         arp_packet = (ARP_PACKET *)packet; /* packetARP_PACKET\̂ɓĂ͂߂ */
         if ((arp_packet -> eth_ethernet_type == 0x0806) && 
             /* ARP̃pPbĝƂ */
             (IP_compare(arp_packet -> arp_dst_IP, src_IP) == 0) && 
             /* pPbgɋLqĂ鈶IPAhXMIPAhXɈvƂ */
             (arp_packet -> arp_operation == 1)
             /* ARPNGXĝƂ */
            )
         {
            packet_type = 'a'; /* packet_type'a'ɂ */
         }
         
         speech_packet = (SPEECH_PACKET *)packet; /* packetSPEECH_PACKET\̂ɓĂ͂߂ */
         if ((speech_packet -> eth_ethernet_type == 0x0800) && 
             /* IP̃pPbĝƂ */
             (IP_compare(speech_packet -> ip_dst_IP, src_IP) == 0) && 
             /* pPbgɋLqĂ鈶IPAhXMIPAhXɈvƂ */
             (speech_packet -> ip_protocol == 17) && 
             /* UDP̃pPbĝƂ */
             (speech_packet -> udp_dst_port == src_port) && 
             /* pPbgɋLqĂ鈶|[gԍM|[gԍɈvƂ */
             (speech_packet_error_check(packet) != 1)
             /* pPbgɃG[ȂƂ */
            )
         {
            packet_type = 's'; /* packet_type's'ɂ */
         }
      }
      
      switch (packet_type) /* packet_typeɂďs */
      {
         case 'a': /* packet_type'a'̂Ƃ */
            ARP_reply(packet); /* ARPvC */
            break;
         case 's': /* packet_type's'̂Ƃ */
            speech_packet = (SPEECH_PACKET *)packet; /* packetSPEECH_PACKET\̂ɓĂ͂߂ */
            if (da_buffer_flag == 0) /* da_buffer_flag0̂Ƃ */
            {
               for (i = 0; i < 160; i++)
               {
                  da_buffer1[i] = speech_packet -> speech_data[i];
                  /* pPbgɓڂĂ鉹f[^da_buffer1Ɋi[ */
               }
            }
            else if (da_buffer_flag == 1) /* da_buffer_flag1̂Ƃ */
            {
               for (i = 0; i < 160; i++)
               {
                  da_buffer0[i] = speech_packet -> speech_data[i];
                  /* pPbgɓڂĂ鉹f[^da_buffer0Ɋi[ */
               }
            }
            break;
      }
   }
}
